﻿Imports System.Web.Mvc
Imports Mvc3RavenDbEmbed.Models
Imports Raven.Client

Namespace Controllers
    Public Class BaseDocumentStoreController
        Inherits Controller
        Public Property DocumentSession() As IDocumentSession

        Protected Overrides Sub OnActionExecuting(ByVal filterContext As ActionExecutingContext)
            If filterContext.IsChildAction Then
                Return
            End If
            Me.DocumentSession = DataDocumentStore.Instance.OpenSession()
            MyBase.OnActionExecuting(filterContext)
        End Sub

        Protected Overrides Sub OnActionExecuted(ByVal filterContext As ActionExecutedContext)
            If filterContext.IsChildAction Then
                Return
            End If
            If Me.DocumentSession IsNot Nothing AndAlso filterContext.Exception Is Nothing Then
                Me.DocumentSession.SaveChanges()
            End If
            Me.DocumentSession.Dispose()
            MyBase.OnActionExecuted(filterContext)
        End Sub
    End Class
End Namespace