﻿'INSTANT VB NOTE: This code snippet uses implicit typing. You will need to set 'Option Infer On' in the VB file or set 'Option Infer' at the project level.

Imports System
Imports System.Linq
Imports System.Web.Mvc
Imports Mvc3RavenDbEmbed.Models
Imports Raven.Client.Linq

Namespace Controllers
    Public Class BookmarksController
        Inherits BaseDocumentStoreController
        Public Function Index() As ViewResult
            Dim model = Me.DocumentSession.Query(Of Bookmark)().OrderByDescending(Function(i) i.DateCreated).ToList()
            Return View(model)
        End Function

        Public Function Details(ByVal id As String) As ViewResult
            Dim model = Me.DocumentSession.Load(Of Bookmark)(id)
            Return View(model)
        End Function

        Public Function Create() As ActionResult
            Dim model = New Bookmark()
            Return View(model)
        End Function

        <HttpPost()>
        Public Function Create(ByVal bookmark As Bookmark) As ActionResult
            bookmark.DateCreated = Date.UtcNow
            Me.DocumentSession.Store(bookmark)
            Return RedirectToAction("Index")
        End Function

        Public Function Edit(ByVal id As String) As ActionResult
            Dim model = Me.DocumentSession.Load(Of Bookmark)(id)
            Return View(model)
        End Function

        <HttpPost()>
        Public Function Edit(ByVal bookmark As Bookmark) As ActionResult
            Me.DocumentSession.Store(bookmark)
            Return RedirectToAction("Index")
        End Function

        Public Function Delete(ByVal id As String) As ActionResult
            Dim model = Me.DocumentSession.Load(Of Bookmark)(id)
            Return View(model)
        End Function

        <HttpPost(), ActionName("Delete")>
        Public Function DeleteConfirmed(ByVal id As String) As ActionResult
            Me.DocumentSession.Advanced.DatabaseCommands.Delete(id, Nothing)
            Return RedirectToAction("Index")
        End Function

        'INSTANT VB NOTE: The parameter tag was renamed since Visual Basic will not allow parameters with the same name as their enclosing function or property:
        Public Function Tag(ByVal tag_Renamed As String) As ViewResult
            Dim model = New BookmarksByTagViewModel With {.Tag = tag_Renamed}
            model.Bookmarks = Me.DocumentSession.Query(Of Bookmark)().Where(Function(i) i.Tags.Any(Function(t) t = tag_Renamed)).OrderByDescending(Function(i) i.DateCreated).ToList()
            Return View(model)
        End Function
    End Class
End Namespace